# sb::Local::nz
# == Author(s) : Takuya Otani <takuya.otani@gmail.com> ==
# == Copyright (C) 2004 SimpleBoxes/SerendipityNZ Ltd. ==

# ======================================
package sb::Local::nz;
use strict;
use sb::Local ();
use base qw( sb::Local );
use vars qw( $VERSION );
$VERSION = '0.03';
# 0.03 [2006/03/22] changed timezone to use new API
# 0.02 [2006/03/17] changed bracket rule
# 0.01 [2005/10/27] added holidays
# 0.00 [2005/10/25] generated
# --------------------------------------
# // override base class
sub timezone
{
	my $self = shift;
	my $obj  = shift;
	return $self->SUPER::timezone($obj,'Pacific/Auckland');
}
sub holidays
{ # Holidays in New Zealand except holidays in lieu and local holiday.
	my $self = shift;
	my $year = shift;
	my %list = (
		'0101' => 'New Year\'s Day',
		'0102' => 'Day after new year\'s day',
		'0206' => 'Waitangi Day',
		'0425' => 'ANZAC Day',
		'1225' => 'Christmas Day',
		'1226' => 'Boxing Day',
	);
	{ # Easter
		my ($mon,$day) = $self->_easter($year);
		my $easter = sb::Time->new('year'=>$year,'mon'=>$mon,'day'=>$day);
		$list{$mon . $day} = 'Easter Sunday'; # Easter is Sunday
		$list{$easter->diff('day'=>-2)->format('form'=>'%Mon%%Day%')} = 'Good Friday';
		$list{$easter->diff('day'=>+1)->format('form'=>'%Mon%%Day%')} = 'Easter Monday';
	}
	{ # Queen's birthday & Labour day
		my $day;
		$day = $self->_weekday('year'=>$year,'mon'=> 6,'nth'=>1,'week'=>1);
		$list{'06' . $self->_pad0($day)} = 'Queen\'s Birthday';
		$day = $self->_weekday('year'=>$year,'mon'=>10,'nth'=>4,'week'=>1);
		$list{'10' . $self->_pad0($day)} = 'Labour Day';
	}
	# foreach my $date (keys(%list))
	# { # A holiday in lieu
	# 	my $mon = substr($date,0,2);
	# 	my $day = substr($date,2,2);
	# 	my $weekday = sb::Time->get_weekday('year'=>$year,'mon'=>$mon,'day'=>$day);
	# 	$list{$mon . $self->_pad0($day + 1)} = 'A holiday in lieu' if ($weekday == 0);
	# }
	return $self->holidays_base(%list);
}
1;
__END__
