# sb::Test
# == Author(s) : Takuya Otani <takuya.otani@gmail.com> ==
# == Copyright (C) 2005 SimpleBoxes/SerendipityNZ Ltd. ==

# ======================================
package sb::Test;
use strict;
use sb::Object ();
use base qw( sb::Object );
use vars qw( $VERSION );
$VERSION = '0.04';
# 0.04 [2007/11/29] modified initialize to initialize SB global object
# 0.03 [2007/08/01] fixed a bug in run to set wrong variable
# 0.02 [2007/07/20] removed unnecessary comments
# 0.01 [2007/07/16] changed return to make them consistent
# 0.00 [2007/07/13] created
# --------------------------------------
# // defines / static variables
sub RESULT_OK (){ 'ok' };
sub RESULT_NG (){ '** NG **' };
# --------------------------------------
# // override base class
sub initialize
{
	my $self = shift;
	require sb;
	sb->new('Test','without_db'=>'yes'); # initialize sb
	return $self->SUPER::initialize();
}
# --------------------------------------
# // public functions
sub add
{
	my $self = shift;
	my $name = shift;
	my $callback = shift;
	my $expected = shift;
	return if (!$name);
	return if (!$callback or ref($callback) ne 'CODE');
	$self->{$name} = {'call'=>$callback,'comp'=>$expected};
}
sub run
{
	my $self = shift;
	my @lists = sort { $a cmp $b } keys %{$self};
	foreach my $name ( @lists )
	{
		print $name,' => ';
		my $result = undef;
		eval { # do test
			my $check = &{$self->{$name}->{'call'}}();
			if (defined($self->{$name}->{'comp'}))
			{ # check the result
				if (ref($self->{$name}->{'comp'}) eq 'CODE')
				{
					$result = (&{$self->{$name}->{'comp'}}($check)) 
						? RESULT_OK 
						: RESULT_NG;
				}
				else
				{
					$result = ($self->{$name}->{'comp'} eq $check) 
						? RESULT_OK 
						: RESULT_NG;
				}
			}
			else
			{ # do nothing
				$result = RESULT_OK;
			}
		}; # end of test
		$result = RESULT_NG . ' ... ' . $@ if ($@);
		print $result,"\n";
	}
}
1;
__END__
