#!/usr/bin/perl
# 
# test script for Serene Bach libraries
# == written by T.Otani <ootani@segausers.gr.jp> ===
# == Copyright (C) 2004 SimpleBoxes/SerendipityNZ ==

# ======================================
use strict;
use warnings;
use lib qw(./ ../);
use sb::Test;
sb::Test::Template->run();

package sb::Test::Template;
use vars qw( $VERSION );
$VERSION = '0.01';
# 0.01 [2007/07/16] changed return to make them consistent
# 0.00 [2007/07/13] created
# --------------------------------------
# // public functions
sub run
{
	my $testcase = sb::Test->new();
	$testcase->add('template',\&_test,_result());
	$testcase->run();
}
# --------------------------------------
# // private functions
sub _test
{
	require sb::Template;
	my $data = _data();
	# print $data;
	my $temp = sb::Template->new($data);
	foreach my $i (0 .. 1)
	{
		$temp->num($i);
		$temp->tag('tag1'=>'TAG1-'.$i);
		$temp->tag('tag2'=>'TAG2-'.$i);
	}
	$temp->block('test1'=>2);
	$temp->block('test2'=>1);
	my $result = $temp->output();
	# print $result;
	return $result;
}
sub _data
{
	return <<'__TEST_TEMP_DATA__';
_main-1
<!-- BEGIN test1 -->
test1-1 {tag1}
<!-- BEGIN test2 -->
test2
<!-- END test2 -->
test1-2 {tag2}
<!-- END test1 -->
_main-2
__TEST_TEMP_DATA__
}
sub _result
{
	return <<'__TEST_TEMP_EXPECTED__';
_main-1
test1-1 TAG1-0
test2
test1-2 TAG2-0
test1-1 TAG1-1
test2
test1-2 TAG2-1
_main-2
__TEST_TEMP_EXPECTED__
}
1;
__END__
